* ram. s
*
* ramdisk for atari 520 st+
* written nov 85 by Jens-Uwe Mager
*
;9 512
;10 1024
;11 2048
;12 4096

;secSize			equ	8192
;rdSize			equ	2
;fatSize			equ	4
;clusters		equ	32000

* atari globals
xbios		equ	14
tos			equ	1

keepterm	equ	$31
supexec		equ	38

initDrive:
	pea     vecinit
	move.w  #supexec,-(sp)
	trap    #14
	addq.l  #6,sp
	rts

vecinit:   

	move.l	#rw,hdv_rw
	move.l	#bpb,hdv_bpb
	move.l	#media,hdv_media 
	move.l	#7,drvbits		;set available drives
	bsr		setupBpb
	rts

alloccaches_malloc:
	move.l	buflData,a0
	beq		Drivenocache
	move	#-1,4(a0)

	move	UDDISectorSize,d0
	ext.l	d0

	move.l	a0,-(a7)
	move	UDDISectorSize,d0
	ext.l	d0
	move.l	d0,-(sp) ; Offset 2
	move.w	#72,-(sp)    ; Offset 0
	trap	#1           ; GEMDOS
	addq.l	#6,sp        ; Correct stack
	move.l	(a7)+,a0
	move.l	d0,16(a0)

	move.l	(a0),a0

	move	#-1,4(a0)
	move.l	a0,-(a7)
	move	UDDISectorSize,d0
	ext.l	d0
	move.l	d0,-(sp) 	; Offset 2
	move.w	#72,-(sp)    ; Offset 0
	trap	#1           ; GEMDOS
	addq.l	#6,sp        ; Correct stack
	move.l	(a7)+,a0
	move.l	d0,16(a0)

	move.l	buflFatDir,a0
	beq		Drivenocache
	move	#-1,4(a0)

	move.l	a0,-(a7)
	move	UDDISectorSize,d0
	ext.l	d0
	move.l	d0,-(sp) ; Offset 2
	move.w	#72,-(sp)    ; Offset 0
	trap	#1           ; GEMDOS
	addq.l	#6,sp        ; Correct stack
	move.l	(a7)+,a0
	move.l	d0,16(a0)

	move.l	(a0),a0

	move	#-1,4(a0)
	move.l	a0,-(a7)
	move	UDDISectorSize,d0
	ext.l	d0
	move.l	d0,-(sp) ; Offset 2
	move.w	#72,-(sp)    ; Offset 0
	trap	#1           ; GEMDOS
	addq.l	#6,sp        ; Correct stack
	move.l	(a7)+,a0
	move.l	d0,16(a0)
	
;	move.l	#screen,d0
	move.l	phystop,d0
	sub.l	#$8000,d0

	rts
/*
alloccaches:
	move.l	buflData,a0
	beq		Drivenocache
	move	#-1,4(a0)

	move	UDDISectorSize,d0
	ext.l	d0

	move.l	membot,16(a0)
	add.l	d0,membot

	move.l	(a0),a0

	move	#-1,4(a0)
	move.l	membot,16(a0)
	add.l	d0,membot

	move.l	buflFatDir,a0
	beq		Drivenocache
	move	#-1,4(a0)

	move.l	membot,16(a0)
	add.l	d0,membot

	move.l	(a0),a0

	move.l	membot,16(a0)
	add.l	d0,membot
	move.l	membot,$4fa

	rts

alloccaches_top:
	move.l	buflData,a0
	beq		Drivenocache
	move	#-1,4(a0)

	move	UDDISectorSize,d0
	ext.l	d0
;	lea		ramValuePos,a1
	lea		screen,a1

	sub.l	d0,a1
	move.l	a1,16(a0)

	move.l	(a0),a0
	move	#-1,4(a0)
	sub.l	d0,a1
	move.l	a1,16(a0)

	move.l	buflFatDir,a0
	beq		Drivenocache
	move	#-1,4(a0)

	sub.l	d0,a1
	move.l	a1,16(a0)

	move.l	(a0),a0
	sub.l	d0,a1
	move.l	a1,16(a0)
	move.l	a1,d0
	rts
*/
Drivenocache
	move	#$f00,$ffff8240.w
	rts

rw:	;Rwabs Bios 4
	;-> 4(sp) read write
	;-> 6(sp) destination buffer can be odd !
	;-> 10(sp) number of blocks
	;-> 12(sp) start block
	;-> 14(sp) drive numer 0 1 2 3 etc.
	;-> 16(sp) start block .l
	;	bit 0 -> 0 read 1 write
	;	bit 1 consider media change
	;	bit 2 retry only ahdi
	;	bit 3 normal or phy mode only  ahdi
	;<- d0 result 0 no error

	move.w	UDDIDriveNumber,d0	;is it our drive?
	cmp.w	14(sp),d0
	bne		oldrwjmp

	movem.l	d1-a6,-(a7)
	move.l	6+(14*4)(sp),a0	;tos buffer
	move.w	12+(14*4)(sp),d0	;Start block
	move.w	10+(14*4)(sp),d1	;nr of blocks
	bsr		UDDIReadSector
	movem.l	(a7)+,d1-a6
	rts

oldrwjmp:
	move.l	UDDIHdvRW,a0
	jmp		(a0)

bpb:
	; Getpbp bios 7
	; ->4(sp) drive
	; <-d0 bpb structure
	move.w	UDDIDriveNumber,d0
	cmp.w	4(sp),d0
	bne.s	oldbpbjmp
	bsr		setupBpb
	bsr		UDGetVarRamPos
	lea		driveBpb(a6),a6
	move.l	a6,d0
;	move.l	#driveBpb,d0
	rts

oldbpbjmp:
	move.l	UDDIHdvBpb,a0
	jmp		(a0)

media:
	move.w	UDDIDriveNumber,d0
	cmp.w	4(sp),d0
	bne.s	oldmediajmp
	moveq	#0,d0
	rts

oldmediajmp:
	move.l	UDDIHdvMedia,a0
	jmp		(a0)

setupBpb:
	bsr		UDGetVarRamPos

	move	UDDISectorSize,d0
	move	d0,driveBpbSectorSize(a6)
	move	#2,driveBpbClSize(a6)
	add		d0,d0
	move	d0,driveBpbClSizeBytes(a6)
	move	UDDIDirSize,driveBpbRootSize(a6)
	move	UDDIFatSize,driveBpbFatSize(a6)
	move	UDDIFatSize,d0
	addq	#1,d0
	move	d0,driveBpbFatSector(a6)

	move	UDDIFatSize,d0
	add		d0,d0
	add		UDDIDirSize,d0
	addq	#1,d0
	move	d0,driveBpbDataSector(a6)
	move	#32760,driveBpbClNum(a6)
	move	#1,driveBpbFlags(a6)
	rts
	
/*
; bpb block
mybpb:	dc.w	secSize				;bytes per sector
clsiz:	dc.w	2					;sectors per cluster
clsizb:	dc.w	secSize*2			;bytes per cluster
rdlen:	dc.w	rdSize				;directory len in sectors
fsiz:	dc.w	fatSize				;fat size in sectors
fatrec:	dc.w	1+fatSize			;start sector of second fat
datrec:	dc.w	1+rdSize+(2*fatSize);start sector of data (boot 1 + rdlen 7 + fsiz*2 10 ) == 18
numcl:	dc.w	clusters
bflags:	dc.w	1					;0=12 bit fat... 1=16 fat
*/